/******************************************************
 ***
 ** Project 'Roleplay'
 **		Hochschule Furtwangen University
 **		© 2013
 ***
 *** 
 ** GameEditor
 ** 	Drag-On
 ***
 *****************************************************/
package application.windows;

import game.GameHandler;
import game.states.MapState;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Spinner;

/**
 * @author Drag-On
 * 
 */
public class ShiftMapWindow extends AbstractDialogWindow
{
	/**
	 * Spinner for x shift
	 */
	private Spinner spinnerX;

	/**
	 * Spinner for y shift
	 */
	private Spinner spinnerY;

	/**
	 * Constructor
	 * 
	 * @param parent
	 */
	protected ShiftMapWindow(Shell parent)
	{
		super(parent);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected void createContents(Composite mainComp)
	{
		Composite content = new Composite(mainComp, SWT.NONE);
		content.setLayout(new GridLayout(4, false));
		content.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		Label labelX = new Label(content, SWT.NONE);
		labelX.setText("X:");
		spinnerX = new Spinner(content, SWT.BORDER);
		spinnerX.setMaximum(100);
		spinnerX.setMinimum(-100);
		spinnerX.setSelection(0);
		Label labelY = new Label(content, SWT.NONE);
		labelY.setText("Y:");
		spinnerY = new Spinner(content, SWT.BORDER);
		spinnerY.setMaximum(100);
		spinnerY.setMinimum(-100);
		spinnerY.setSelection(0);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected String getTitle()
	{
		return "Shift map";
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected void onCancel(SelectionEvent e)
	{
		close();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	protected void onOK(SelectionEvent e)
	{
		MapState mapState = (MapState) GameHandler.getInstance().getState(
				GameHandler.STATE_MAP);
		mapState.getMapData().shift(spinnerX.getSelection(),
				spinnerY.getSelection());

		MapWindow.setDirty(true);

		close();
	}
}
