/******************************************************
 ***
 ** Project 'Roleplay'
 **		Hochschule Furtwangen University
 **		© 2012
 ***
 *** 
 ** GameEditor
 ** 	Drag-On
 ***
 *****************************************************/
package application.windows.history;

import java.util.ArrayList;
import java.util.List;

/**
 * This class represents one step in the undo-history of the map editor
 * 
 * @author Drag-On
 * 
 */
public class HistoryNode
{
	/**
	 * Contains the rectangle of edited tiles on the map
	 */
	private List<HistoryNodeTileChange> editedTiles = new ArrayList<HistoryNodeTileChange>();

	/**
	 * Constructor
	 * 
	 * @param editedTiles
	 *            List of edited tiles on the map
	 */
	public HistoryNode(List<HistoryNodeTileChange> editedTiles)
	{
		this.editedTiles = editedTiles;
	}

	/**
	 * @return the editedTiles
	 */
	public List<HistoryNodeTileChange> getEditedTiles()
	{
		return editedTiles;
	}
}
