/******************************************************
 ***
 ** Project 'Roleplay'
 **		Hochschule Furtwangen University
 **		© 2012
 ***
 *** 
 ** GameEditor
 ** 	Drag-On
 ***
 *****************************************************/
package application.windows.history;

import org.lwjgl.util.Point;

/**
 * This class represents a change in one tile
 * 
 * @author Drag-On
 * 
 */
public class HistoryNodeTileChange
{
	/**
	 * Position of the changed tile on the map
	 */
	private Point mapPos = new Point();

	/**
	 * Position of the tile on the tileset before change
	 */
	private Point oldTilePos = new Point();

	/**
	 * Layer of the tile on the map
	 */
	private final int layer;

	/**
	 * Constructor
	 * 
	 * @param mapPos
	 *            Position of the changed tile on the map
	 * @param oldTilePos
	 *            Position of the tile on the tileset before change
	 * @param layer
	 *            Layer of the tile on the map
	 */
	public HistoryNodeTileChange(Point mapPos, Point oldTilePos, int layer)
	{
		this.mapPos = mapPos;
		this.oldTilePos = oldTilePos;
		this.layer = layer;
	}

	/**
	 * @return the mapPos
	 */
	public Point getMapPos()
	{
		return mapPos;
	}

	/**
	 * @return the oldTilePos
	 */
	public Point getOldTilePos()
	{
		return oldTilePos;
	}

	/**
	 * @return the layer
	 */
	public int getLayer()
	{
		return layer;
	}
}
