/******************************************************
 ***
 ** Project 'Roleplay'
 **		Hochschule Furtwangen University
 **		© 2012
 ***
 *** 
 ** GameLib
 ** 	Drag-On
 ***
 *****************************************************/
package application.event;

import java.util.EventObject;

import org.newdawn.slick.Input;

/**
 * This class describes all kinds of keyboard events
 * 
 * @author Drag-On
 * 
 */
public class KeyboardEvent extends EventObject
{
	/**
	 * Serial Version UID
	 */
	private static final long serialVersionUID = -7974713278036009637L;

	/**
	 * Keycode of the pressed key
	 */
	private int keyCode = -1;

	/**
	 * Character of the key pressed
	 */
	private char key = ' ';

	/**
	 * Constructor
	 * 
	 * @param source
	 *            Initial source object
	 * @param keyCode
	 *            Keycode of the key that has been pressed, defined in
	 *            {@link Input}
	 * @param key
	 *            Character of the key that was pressed
	 */
	public KeyboardEvent(final Object source, final int keyCode, final char key)
	{
		super(source);
		this.keyCode = keyCode;
		this.key = key;
	}

	/**
	 * @return the keyCode
	 */
	public int getKeyCode()
	{
		return keyCode;
	}

	/**
	 * @return the key
	 */
	public char getKey()
	{
		return key;
	}
}
