/******************************************************
 ***
 ** Project 'Roleplay'
 **		Hochschule Furtwangen University
 **		© 2012
 ***
 *** 
 ** GameLib
 ** 	Drag-On
 ***
 *****************************************************/
package application.event.listener;

import java.util.EventListener;

import application.event.MouseEvent;

/**
 * A mouse event listener
 * 
 * @author Drag-On
 * 
 */
public interface MouseEventListener extends EventListener
{
	/**
	 * A mouse button has been clicked
	 * 
	 * @param e
	 */
	public void mouseClicked(MouseEvent e);

	/**
	 * A mouse button has been released
	 * 
	 * @param e
	 */
	public void mouseReleased(MouseEvent e);

	/**
	 * A mouse button has been pressed
	 * 
	 * @param e
	 */
	public void mousePressed(MouseEvent e);

	/**
	 * The mouse has been dragged with a pressed button
	 * 
	 * @param e
	 */
	public void mouseDragged(MouseEvent e);

	/**
	 * The mouse wheel has been scrolled
	 * 
	 * @param e
	 */
	public void mouseWheelMoved(MouseEvent e);

	/**
	 * The mouse cursor has been moved
	 * 
	 * @param e
	 */
	public void mouseMoved(MouseEvent e);
}
