/******************************************************
 ***
 ** Project 'Roleplay'
 **		Hochschule Furtwangen University
 **		© 2013
 ***
 *** 
 ** GameLib
 ** 	Drag-On
 ***
 *****************************************************/
package game.resources;

import game.managers.Resource;

import org.newdawn.slick.Music;
import org.newdawn.slick.SlickException;

/**
 * A resource representing a music track
 * 
 * @author Drag-On
 * 
 */
public class MusicResource extends Resource
{
	/**
	 * Actual music handle
	 */
	private Music music;

	/**
	 * Constructor
	 * 
	 * @param path
	 *            Path to the resource file
	 */
	public MusicResource(final String path)
	{
		super(path);
	}

	/**
	 * Copy-Constructor
	 * 
	 * @param other
	 *            Some other resource of the same type
	 */
	public MusicResource(final MusicResource other)
	{
		super(other);
		this.music = other.music;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean isLoaded()
	{
		return this.music != null;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void load() throws SlickException
	{
		this.music = new Music(getPath(), true);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void unload() throws SlickException
	{
		if (isLoaded())
			this.music.release();
		this.music = null;
	}

	/**
	 * @return the music
	 */
	public Music getMusic()
	{
		return music;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void copyData(final Resource other)
	{
	}
}
