/******************************************************
 ***
 ** Project 'Roleplay'
 **		Hochschule Furtwangen University
 **		 \u00a9 2013
 ***
 *** 
 ** GameLib
 ** 	Drag-On
 ***
 *****************************************************/
package game.states;

import game.GameHandler;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;

/**
 * Game state which calls a method only the first time it is entered
 * 
 * @author Drag-On
 * 
 */
public abstract class AbstractGameState extends BasicGameState
{
	/**
	 * Flag determining if this state has already been initialized
	 */
	private boolean initialized = false;

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void enter(final GameContainer container, final StateBasedGame game)
			throws SlickException
	{
		if (!initialized)
			firstInit(container, game);

		GameHandler.getInstance().getContainer().getInput()
				.clearKeyPressedRecord();
		GameHandler.getInstance().getContainer().getInput()
				.clearControlPressedRecord();
		GameHandler.getInstance().getContainer().getInput()
				.clearMousePressedRecord();
	}

	/**
	 * This method is called on the first entering of this state
	 * 
	 * @param container
	 *            The container holding the game
	 * @param game
	 *            The game holding this state
	 */
	public void firstInit(final GameContainer container,
			final StateBasedGame game)
	{
		initialized = true;
	}
}
