/******************************************************
 ***
 ** Project 'Roleplay'
 **		Hochschule Furtwangen University
 **		 \u00a9 2013
 ***
 *** 
 ** GameLib
 ** 	Drag-On
 ***
 *****************************************************/
package game.states.map.ai.character;

import java.io.Serializable;

/**
 * This interface defines all methods an AI class needs to implement. Not to be
 * confused with {@link IAICharacter}!
 * 
 * @author Drag-On
 * 
 */
public interface ICharacterAI extends Serializable
{
	/**
	 * Initializes the AI
	 * 
	 * @param character
	 *            The character that is controlled by this AI instance
	 */
	public void init(IAICharacter character);

	/**
	 * Updates the AI
	 * 
	 * @param delta
	 *            Time since last update
	 */
	public void update(final int delta);
}
