/******************************************************
 ***
 ** Project 'Roleplay'
 **		Hochschule Furtwangen University
 **		 \u00a9 2013
 ***
 *** 
 ** GameLib
 ** 	Drag-On
 ***
 *****************************************************/
package game.states.map.ai.character.enemy;

import game.states.map.ai.character.AbstractStateBasedCharacterAI;
import game.states.map.ai.character.IAICharacter;
import game.states.map.ai.character.ICharacterAIState;

import java.io.Serializable;

/**
 * A general AI state useful for battling enemies
 * 
 * @author Drag-On
 * 
 */
public abstract class AbstractEnemyAIState implements ICharacterAIState,
		Serializable
{
	/**
	 * Serial Version UID
	 */
	private static final long serialVersionUID = 7030248689244051678L;

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void init(final IAICharacter character,
			final AbstractStateBasedCharacterAI ai)
	{
		init((AbstractEnemyAICharacter) character, (EnemyAI) ai);
	}

	/**
	 * 
	 * @see #init(IAICharacter, AbstractStateBasedCharacterAI)
	 */
	public abstract void init(AbstractEnemyAICharacter character, EnemyAI ai);

	/**
	 * {@inheritDoc}
	 */
	@Override
	public int getCompetenceScore(final IAICharacter character,
			final AbstractStateBasedCharacterAI ai)
	{
		// TODO Auto-generated method stub
		return getCompetenceScore((AbstractEnemyAICharacter) character,
				(EnemyAI) ai);
	}

	/**
	 * @see #getCompetenceScore(IAICharacter, AbstractStateBasedCharacterAI)
	 */
	public abstract int getCompetenceScore(
			final AbstractEnemyAICharacter character, final EnemyAI ai);

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void update(final IAICharacter character,
			final AbstractStateBasedCharacterAI ai, final int delta)
	{
		update((AbstractEnemyAICharacter) character, (EnemyAI) ai, delta);
	}

	/**
	 * @see #update(IAICharacter, AbstractStateBasedCharacterAI, int)
	 */
	public abstract void update(final AbstractEnemyAICharacter character,
			final EnemyAI ai, final int delta);
}
