/******************************************************
 ***
 ** Project 'Roleplay'
 **		Hochschule Furtwangen University
 **		© 2013
 ***
 *** 
 ** GameLib
 ** 	Drag-On
 ***
 *****************************************************/
package game.states.map.ai.pathfinding;

import java.util.List;

import org.lwjgl.util.Point;

/**
 * This is a interface that must be implemented by object that support
 * pathfinding.
 * 
 * @author Drag-On
 * 
 */
public interface IPathfindingObject
{
	/**
	 * Sets the path to walk. Called after a pathfinding process has been
	 * finished by {@link PathfindingManager}
	 * 
	 * @param path
	 *            Calculated path
	 */
	public void setPath(List<Point> path);
}
