/******************************************************
 ***
 ** Project 'Roleplay'
 **		Hochschule Furtwangen University
 **		© 2013
 ***
 *** 
 ** GameLib
 ** 	Drag-On
 ***
 *****************************************************/
package game.states.map.ai.pathfinding;

/**
 * This holds the data about one single pathfinding request
 * 
 * @author Drag-On
 * 
 */
public class PathfindingRequest
{
	/**
	 * Start and target coordinates
	 */
	private final int startX, startY, targetX, targetY;

	/**
	 * The object that requested pathfinding
	 */
	private final IPathfindingObject object;

	/**
	 * Constructor
	 * 
	 * @param object
	 *            The object that requested pathfinding
	 * @param startX
	 *            Start node x coordinate
	 * @param startY
	 *            Start node y coordinate
	 * @param targetX
	 *            Target node x coordinate
	 * @param targetY
	 *            Target node y coordinate
	 */
	public PathfindingRequest(final IPathfindingObject object,
			final int startX, final int startY, final int targetX,
			final int targetY)
	{
		this.object = object;
		this.startX = startX;
		this.startY = startY;
		this.targetX = targetX;
		this.targetY = targetY;
	}

	/**
	 * @return the object
	 */
	public IPathfindingObject getObject()
	{
		return object;
	}

	/**
	 * @return the startX
	 */
	public int getStartX()
	{
		return startX;
	}

	/**
	 * @return the startY
	 */
	public int getStartY()
	{
		return startY;
	}

	/**
	 * @return the targetX
	 */
	public int getTargetX()
	{
		return targetX;
	}

	/**
	 * @return the targetY
	 */
	public int getTargetY()
	{
		return targetY;
	}
}
