/******************************************************
 ***
 ** Project 'Roleplay'
 **		Hochschule Furtwangen University
 **		© 2013
 ***
 *** 
 ** GameLib
 ** 	Drag-On
 ***
 *****************************************************/
package game.states.map.dialog;

import java.util.List;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.state.StateBasedGame;

/**
 * This class encapsulates a single choice of a {@link DialogSelectionNode}.
 * 
 * @author Drag-On
 * 
 */
public class DialogChoiceNode extends AbstractDialogConditionalNode
{
	/**
	 * Message to display inside the button
	 */
	private String msg = "";

	/**
	 * Constructor
	 * 
	 * @param msg
	 *            Message to display inside the button
	 * @param condition
	 *            Condition that has to be met so this choice is visible to the
	 *            player
	 * @param nextNodes
	 *            Next nodes to execute after this one
	 */
	public DialogChoiceNode(final String msg, final String condition,
			final List<IDialogNode> nextNodes)
	{
		super(nextNodes, condition);
		this.msg = msg;
	}

	/**
	 * @return the msg
	 */
	public String getMsg()
	{
		return msg;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void update(final GameContainer container,
			final StateBasedGame game, final int delta)
	{
		// No updating
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void render(final GameContainer container,
			final StateBasedGame game, final Graphics g)
	{
		// No rendering
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean isFinished()
	{
		return true;
	}
}
