/******************************************************
 ***
 ** Project 'Roleplay'
 **		Hochschule Furtwangen University
 **		 \u00a9 2013
 ***
 *** 
 ** GameLib
 ** 	Drag-On
 ***
 *****************************************************/
package game.states.map.dialog;

import java.util.List;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.state.StateBasedGame;

/**
 * A conditional node which can be used to surround other (blocks) of nodes
 * 
 * @author Drag-On
 * 
 */
public class DialogConditionalNode extends AbstractDialogConditionalNode
{
	/**
	 * Constructor
	 * 
	 * @param childNodes
	 *            Child nodes
	 * @param condition
	 *            Condition that has to be met
	 */
	public DialogConditionalNode(final List<IDialogNode> childNodes,
			final String condition)
	{
		super(childNodes, condition);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean isFinished()
	{
		return true;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void update(final GameContainer container,
			final StateBasedGame game, final int delta)
	{
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void render(final GameContainer container,
			final StateBasedGame game, final Graphics g)
	{
	}
}
