/******************************************************
 ***
 ** Project 'Roleplay'
 **		Hochschule Furtwangen University
 **		 \u00a9 2013
 ***
 *** 
 ** GameLib
 ** 	Drag-On
 ***
 *****************************************************/
package game.states.map.entity.triggers;

import game.GameHandler;
import game.resources.DialogResource;
import game.resources.ResourceProvider;
import game.resources.ResourceType;
import game.states.MapState;
import game.states.map.entity.GameEntity;
import game.states.map.entity.PlayerCharacter;
import game.states.map.entity.TriggerZoneEntity;

/**
 * @author Drag-On
 * 
 */
public class StartDialogTrigger extends TriggerZoneEntity
{
	/**
	 * Serial Version UID
	 */
	private static final long serialVersionUID = 2599247164202241050L;

	/**
	 * Constructor
	 * 
	 * @param x
	 *            X coordinate in pixels
	 * @param y
	 *            Y coordinate in pixels
	 * @param width
	 *            Width in pixels
	 * @param height
	 *            Height in pixels
	 */
	public StartDialogTrigger(final int x, final int y, final int width,
			final int height)
	{
		super(x, y, width, height);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void onTrigger(final GameEntity activator)
	{
		super.onTrigger(activator);

		MapState mapState = (MapState) GameHandler.getInstance().getState(
				GameHandler.STATE_MAP);
		DialogResource res = ResourceProvider.getInstance().get(
				getAdditionalData(), ResourceType.DIALOG);
		mapState.getMapData().startDialog(res.getDialogRoot());
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void onEntityLeft(final GameEntity activator)
	{
		super.onEntityLeft(activator);
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean canTrigger(final GameEntity activator)
	{
		return super.canTrigger(activator)
				&& activator instanceof PlayerCharacter;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public boolean deleteOnTrigger()
	{
		return false;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void requestResources()
	{
		ResourceProvider.getInstance().get(getAdditionalData(),
				ResourceType.DIALOG);
	}
}
