/******************************************************
 ***
 ** Project 'Roleplay'
 **		Hochschule Furtwangen University
 **		© 2013
 ***
 *** 
 ** GameLib
 ** 	Drag-On
 ***
 *****************************************************/
package game.states.map.entity.triggers.map;

/**
 * A generic map trigger which causes the viewport to shake at a high frequency
 * 
 * @author Drag-On
 * 
 */
public class CamShakeMapTrigger extends DialogMapTrigger
{
	/**
	 * {@inheritDoc}
	 */
	@Override
	public void onInit()
	{
		getMap().getViewport().setHorizontalShakeFrequency(10.0f);
		getMap().getViewport().setVerticalShakeFrequency(10.9f);

		getMap().getViewport().setHorizontalShakeMagnitude(2.0f);
		getMap().getViewport().setVerticalShakeMagnitude(2.0f);

		super.onInit();
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void onTrigger(final int delta)
	{
		getMap().getViewport().setHorizontalShakeStep(
				getMap().getViewport().getHorizontalShakeStep() + delta
						/ 512.0f);
		getMap().getViewport().setVerticalShakeStep(
				getMap().getViewport().getVerticalShakeStep() + delta / 512.0f);
	}
}
