/******************************************************
 ***
 ** Project 'Roleplay'
 **		Hochschule Furtwangen University
 **		 \u00a9 2013
 ***
 *** 
 ** GameLib
 ** 	Drag-On
 ***
 *****************************************************/
package game.states.map.entity.triggers.map;

import game.resources.DialogResource;
import game.resources.ResourceProvider;
import game.resources.ResourceType;

/**
 * This is a general map trigger which interprets the additional data field as a
 * dialog resource which is executed on map initialization
 * 
 * @author Drag-On
 * 
 */
public class DialogMapTrigger extends AbstractMapTriggerEntity
{
	/**
	 * {@inheritDoc}
	 */
	@Override
	public void onInit()
	{
		if (getAdditionalData() != null)
		{
			DialogResource res = ResourceProvider.getInstance().get(
					getAdditionalData(), ResourceType.DIALOG, true);
			getMap().startDialog(res.getDialogRoot());
		}
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public void onTrigger(final int delta)
	{
		// Nothing
	}
}
