/******************************************************
 ***
 ** Project 'Roleplay'
 **		Hochschule Furtwangen University
 **		© 2013
 ***
 *** 
 ** GameLib
 ** 	Drag-On
 ***
 *****************************************************/
package game.states.map.zbufferlist;

/**
 * This interface is used by {@link ZBufferList}s which are needed for drawable
 * objects
 * 
 * @author Drag-On
 * 
 */
public interface IZBufferListItem
{
	/**
	 * @return the next
	 */
	public IZBufferListItem getNext();

	/**
	 * @param next
	 *            the next to set
	 */
	public void setNext(final IZBufferListItem next);

	/**
	 * @return the previous
	 */
	public IZBufferListItem getPrevious();

	/**
	 * @param previous
	 *            the previous to set
	 */
	public void setPrevious(final IZBufferListItem previous);

	/**
	 * @return X coordinate
	 */
	public abstract int getX();

	/**
	 * @return Y coordinate
	 */
	public abstract int getY();

	/**
	 * @return Z coordinate
	 */
	public abstract int getZ();
}
