/******************************************************
 ***
 ** Project 'Roleplay'
 **		Hochschule Furtwangen University
 **		© 2012
 ***
 *** 
 ** GameLib
 ** 	Drag-On
 ***
 *****************************************************/
package game.widget.event;

import java.util.EventObject;

/**
 * This event is fired when something was selected
 * 
 * @author Drag-On
 * 
 */
public class SelectionEvent extends EventObject
{
	/**
	 * Serial Version UID
	 */
	private static final long serialVersionUID = 5463195488026111454L;

	/**
	 * Coordinate values (i.e. used for selected items in lists)
	 */
	private int x = -1, y = -1;

	/**
	 * Constructor
	 * 
	 * @param source
	 *            Source of this event
	 */
	public SelectionEvent(final Object source)
	{
		super(source);
	}

	/**
	 * Constructor
	 * 
	 * @param source
	 *            Source of this event
	 * @param x
	 *            X coordinate inside of the owner of the source of this event
	 * @param y
	 *            Y coordinate inside of the owner of the source of this event
	 */
	public SelectionEvent(final Object source, final int x, final int y)
	{
		super(source);
		this.x = x;
		this.y = y;
	}

	/**
	 * @return the x
	 */
	public int getX()
	{
		return x;
	}

	/**
	 * @return the y
	 */
	public int getY()
	{
		return y;
	}

	/**
	 * @param x the x to set
	 */
	public void setX(int x)
	{
		this.x = x;
	}

	/**
	 * @param y the y to set
	 */
	public void setY(int y)
	{
		this.y = y;
	}
}
