package game.states.map.zbufferlist;

import game.resources.TileData;
import junit.framework.TestCase;

import org.junit.Test;

public class ZBufferListTest extends TestCase
{
	@Test
	public void testAdd()
	{
		ZBufferList<ZBufferListTileItem> list = new ZBufferList<ZBufferListTileItem>();
		assertNull(list.getFirstItem());

		list.add(new ZBufferListTileItem(5, 3, 1, new TileData(true, 0, false,
				0, 0), ""));
		assertNotNull(list.getFirstItem());
		assertEquals(5, list.getFirstItem().getX());
		assertEquals(3, list.getFirstItem().getY());
		assertEquals(1, list.getFirstItem().getZ());

		list.add(new ZBufferListTileItem(3, 3, 1, new TileData(true, 0, false,
				0, 0), ""));
		assertNotNull(list.getFirstItem());
		assertEquals(3, list.getFirstItem().getX());
		assertEquals(3, list.getFirstItem().getY());
		assertEquals(1, list.getFirstItem().getZ());

		list.add(new ZBufferListTileItem(1, 1, 0, new TileData(true, 0, false,
				0, 0), ""));
		assertNotNull(list.getFirstItem());
		assertEquals(1, list.getFirstItem().getX());
		assertEquals(1, list.getFirstItem().getY());
		assertEquals(0, list.getFirstItem().getZ());

		list.add(new ZBufferListTileItem(2, 1, 0, new TileData(true, 0, false,
				0, 0), ""));
		assertNotNull(list.getFirstItem());
		assertEquals(1, list.getFirstItem().getX());
		assertEquals(1, list.getFirstItem().getY());
		assertEquals(0, list.getFirstItem().getZ());

		list.add(new ZBufferListTileItem(2, 1, 10, new TileData(true, 0, false,
				0, 0), ""));
		assertNotNull(list.getFirstItem());
		assertEquals(1, list.getFirstItem().getX());
		assertEquals(1, list.getFirstItem().getY());
		assertEquals(0, list.getFirstItem().getZ());

		// Add the same item twice to check, if it's correctly refused
		ZBufferListTileItem zItem = new ZBufferListTileItem(0, 0, 0,
				new TileData(true, 0, false, 0, 0), "");
		list.add(zItem);
		assertNotNull(list.getFirstItem());
		assertEquals(0, list.getFirstItem().getX());
		assertEquals(0, list.getFirstItem().getY());
		assertEquals(0, list.getFirstItem().getZ());

		list.add(zItem);
		assertNotNull(list.getFirstItem());
		assertEquals(0, list.getFirstItem().getX());
		assertEquals(0, list.getFirstItem().getY());
		assertEquals(0, list.getFirstItem().getZ());
		list.removeFirstItem();
		assertNotNull(list.getFirstItem());
		assertEquals(1, list.getFirstItem().getX());
		assertEquals(1, list.getFirstItem().getY());
		assertEquals(0, list.getFirstItem().getZ());
	}

	@Test
	public void testRemoveFirst()
	{
		ZBufferList<ZBufferListTileItem> list = new ZBufferList<ZBufferListTileItem>();
		assertNull(list.getFirstItem());

		list.add(new ZBufferListTileItem(5, 3, 1, new TileData(true, 0, false,
				0, 0), ""));
		list.add(new ZBufferListTileItem(3, 3, 1, new TileData(true, 0, false,
				0, 0), ""));
		list.add(new ZBufferListTileItem(1, 3, 4, new TileData(true, 0, false,
				0, 0), ""));

		assertEquals(3, list.getFirstItem().getX());
		assertEquals(3, list.getFirstItem().getY());
		assertEquals(1, list.getFirstItem().getZ());

		list.removeFirstItem();

		assertEquals(5, list.getFirstItem().getX());
		assertEquals(3, list.getFirstItem().getY());
		assertEquals(1, list.getFirstItem().getZ());

		list.removeFirstItem();

		assertEquals(1, list.getFirstItem().getX());
		assertEquals(3, list.getFirstItem().getY());
		assertEquals(4, list.getFirstItem().getZ());

		list.removeFirstItem();

		assertNull(list.getFirstItem());
	}
}
